part of tecfy_core_client_package;

abstract class IEntityTransaction {
  Future<OperationResultEntityTransaction<Map<String, dynamic>>> beforeAdd(
      BuildContext context, Map<String, dynamic> data);
  Future<OperationResultEntityTransaction<Map<String, dynamic>>> beforeUpdate(
      BuildContext context, Map<String, dynamic> data);
  Future<OperationResultEntityTransaction<Map<String, dynamic>>> beforeDelete(
      BuildContext context, String id);

  Future<OperationResultEntityTransaction> afterAdd(
      BuildContext context, Map<String, dynamic> data);
  Future<OperationResultEntityTransaction> afterUpdate(
      BuildContext context, Map<String, dynamic> data);
  Future<OperationResultEntityTransaction> afterDelete(
      BuildContext context, String id);
}

class OperationResultEntityTransaction<T> extends OperationResult<T> {
  bool skip;
  OperationResultEntityTransaction(
      {bool success, T data, this.skip, String message})
      : super(data: data, success: success, message: message);
}
